unit U_MLMange_XH;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxTextEdit,
  cxButtonEdit, Menus, cxLookAndFeelPainters, cxButtons, cxImage, BtnEdit,
  jpeg;

type
  TfrmMLMange_XH = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBClose: TToolButton;
    DataSource1: TDataSource;
    ADOQueryTree: TADOQuery;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    DataSource2: TDataSource;
    ADOQueryMain: TADOQuery;
    CDS_Main: TClientDataSet;
    ToolButton1: TToolButton;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    ODPat: TOpenDialog;
    IdFTP1: TIdFTP;
    SaveDialog1: TSaveDialog;
    DataSource3: TDataSource;
    cxGridPopupMenu2: TcxGridPopupMenu;
    Order_GX: TClientDataSet;
    DataSource4: TDataSource;
    cxGridPopupMenu3: TcxGridPopupMenu;
    ML_Col: TClientDataSet;
    DataSource5: TDataSource;
    cxGridPopupMenu4: TcxGridPopupMenu;
    CDS_Sub: TClientDataSet;
    cxStyleRepository1: TcxStyleRepository;
    cxStyle1: TcxStyle;
    cxGridPopupMenu5: TcxGridPopupMenu;
    DataSource6: TDataSource;
    Ord_HX: TClientDataSet;
    ADOQuery1: TADOQuery;
    TCK: TToolButton;
    ToolButton11: TToolButton;
    Panel5: TPanel;
    Label2: TLabel;
    TJML: TEdit;
    Label1: TLabel;
    Label4: TLabel;
    MLName: TEdit;
    TJGYName: TEdit;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1TJML: TcxGridDBColumn;
    v1MLName: TcxGridDBColumn;
    v1MLMF: TcxGridDBColumn;
    v1MLKZ: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1TJGYName: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    Label3: TLabel;
    v1MLXXGYName: TcxGridDBColumn;
    v1HXType: TcxGridDBColumn;
    v1MLXXNO: TcxGridDBColumn;
    v1ColGS: TcxGridDBColumn;
    Label5: TLabel;
    MLXXNO: TEdit;
    Label6: TLabel;
    MLKZ: TEdit;
    Label7: TLabel;
    Button1: TButton;
    HXType: TEdit;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Panel2: TPanel;
    cxButton1: TcxButton;
    cxButton2: TcxButton;
    cxButton3: TcxButton;
    ToPrint: TToolButton;
    Label8: TLabel;
    RM2: TRMGridReport;
    Image1: TImage;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cxDBTreeList1DblClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ToolButton10Click(Sender: TObject);
    procedure TV4CellClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure Tv1DblClick(Sender: TObject);
    procedure TCKClick(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure TPrintClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure HXTypeChange(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure ToPrintClick(Sender: TObject);
    procedure cxButton1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure cxButton2Click(Sender: TObject);
    procedure cxButton3Click(Sender: TObject);
  private
    { Private declarations }
    PState:Integer;
    FCPID,FTopID:String;
    procedure InitTree();
    procedure InitGrid();
    procedure ReadINIFile();
  public
    canshu1:string;
    { Public declarations }
  end;

var
  frmMLMange_XH: TfrmMLMange_XH;

implementation
uses
  U_DataLink,U_Fun,U_CPAdd,U_FileUp,U_MLManage_LR,U_BPZdy_LR,U_BPZdy_SH,U_MLManage_LRRS,U_HXKTJ,
  U_MLManage_FHLR,U_MLManage_ZHLR,U_BPZdy_HXK,U_MLMange_CX,U_BPZdy_LRPB,U_BPZdy_LRGX,U_BPZdy_ColTJ,
  U_CPManage_TP,U_BPZdy_LRSHK, U_BPZdy_PanelCX,U_BPZdy_Panel,U_MLManage_LRTJ,U_MLManage_LRTJ_Ceshi1,
  U_SCPerson,U_MLManage_LRYH,U_MLManage_LRYHDY;

{$R *.dfm}

procedure TfrmMLMange_XH.InitTree();
begin
  
end;

procedure TfrmMLMange_XH.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Close;
      SQL.Clear;
      SQL.Add('select *,MLDLNo SKID ');
      sql.Add(',ColGS=(select count(B.TJML) from Image_Info B where B.TJML=A.TJML and B.TJGYName=A.TJGYName)');
      sql.Add(' from ML_Manage A ');
      sql.Add(' where isnull(A.MLType,'''')=''绣花面料'' ');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmMLMange_XH.FormDestroy(Sender: TObject);
begin
  frmMLMangeYH:=nil;
end;

procedure TfrmMLMange_XH.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmMLMange_XH.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('绣花面料1',Tv1,'样品管理');
  Close;
end;
procedure TfrmMLMange_XH.FormShow(Sender: TObject);
begin
  {if canshu1='高权限' then
  begin
    toolbutton11.Visible:=True;
    ToolButton3.Visible:=true;
    TBDel.Visible:=true;
  end
  else
  begin
    if canshu1='查询' then
    begin
      toolbutton11.Visible:=false;
      ToolButton3.Visible:=false;
      TBDel.Visible:=false;
    end
    else
    begin
      toolbutton11.Visible:=false;
      ToolButton3.Visible:=false;
      TBDel.Visible:=false;
    end;
  end;}
  InitGrid();
  ReadCxGrid('印花面料1',Tv1,'样品管理');
end;

procedure TfrmMLMange_XH.cxDBTreeList1DblClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmMLMange_XH.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  end;
end;

procedure TfrmMLMange_XH.ToolButton2Click(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel5,1,2));
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  end;
end;

procedure TfrmMLMange_XH.ToolButton1Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  TcxGridToExcel('客户拿样',cxGrid1);
end;

procedure TfrmMLMange_XH.ReadINIFile();
var
  programIni:Tinifile;  //配置文件名
  FileName:string;
begin
  FileName:=ExtractFilePath(Paramstr(0))+'SYSTEMSET.INI';
  programIni:=Tinifile.create(FileName);
  server:=programIni.ReadString('SERVER','服务器地址','127.0.0.1');
  programIni.Free;
end;

procedure TfrmMLMange_XH.Tv1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  with ADOQueryCmd do
  begin
    Close;
    SQL.Clear;
    sql.Add(' select A.*,isnull(B.BPCode,C.MLNo) BPCode,isnull(B.BPName,C.MLName) BPName');
    sql.Add(' ,isnull(B.BPMF,C.MLMF) BPMF,isnull(B.BPKZ,C.MLKZ) BPKZ');
    sql.Add(',B.BPJS,B.BPWS,B.BPMiDu,B.BPUnit,C.MLDLNo,C.DLHXK');
    SQL.Add(' from ML_Manage_PB A left join BP_ZDY B on B.BPID=A.BPID ');
    sql.Add(' left join ML_Manage C on C.MLID=A.BPID');
    sql.Add(' where A.MLID='''+Trim(CDS_Main.fieldbyname('MLID').AsString)+'''');
    //ShowMessage(sql.Text);
    Open;
  end;
  SCreateCDS20(ADOQueryCmd,CDS_Sub);
  SInitCDSData20(ADOQueryCmd,CDS_Sub);
  with ADOQueryCmd do
  begin
    Close;
    SQL.Clear;
    sql.Add(' select A.*,B.*,C.* from ML_Manage_GX A inner join BP_ZDY B on B.BPID=A.BPID ');
    sql.Add('inner join BP_ZDY_Sub C on C.BPSubID=A.BPSubID');
    sql.Add(' where A.MLID='''+Trim(CDS_Main.fieldbyname('MLID').AsString)+'''');
    Open;
  end;
  SCreateCDS20(ADOQueryCmd,Order_GX);
  SInitCDSData20(ADOQueryCmd,Order_GX);
  //if CDS_Main.FieldByName('MLType').AsString<>'复合' then
  begin
    //if CDS_Main.FieldByName('MLType').AsString<>'组合' then
    begin
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('select * from BP_ZDY_Sub ');
        sql.Add('where BPCode='''+Trim(CDS_Main.fieldbyname('MLDLNo').AsString)+''' and BPflag=''SHK''');
        Open;
      end;
      SCreateCDS20(ADOQueryCmd,ML_Col);
      SInitCDSData20(ADOQueryCmd,ML_Col);
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select A.*,B.* from BP_ZDY_Sub A ');
      Sql.Add('inner join KH_Zdy_Attachment B on A.HXATID=B.ATID and B.Type=''CPHX''');
      sql.Add(' where A.BPCode='''+trim(CDS_Main.fieldbyname('DLHXK').AsString)+'''');
      open;
    end;
    SCreateCDS20(ADOQueryCmd,Ord_HX);
    SInitCDSData20(ADOQueryCmd,Ord_HX);
  end;
end;

procedure TfrmMLMange_XH.ToolButton10Click(Sender: TObject);
begin
  {if RadioGroup1.ItemIndex=-1 then
  begin
    application.MessageBox('请选择工序','提示');
    exit;
  end;}
  
end;

procedure TfrmMLMange_XH.TV4CellClick(Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  //if CDS_Main.FieldByName('MLType').AsString='复合' then
  begin
    with ADOQuery1 do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from BP_ZDY_Sub ');
      sql.Add('where BPCode='''+Trim(CDS_Sub.Fieldbyname('MLDLNo').AsString)+''' and BPflag=''SHK''');
      Open;
    end;
    SCreateCDS20(ADOQuery1,ML_Col);
    SInitCDSData20(ADOQuery1,ML_Col);
    with ADOQuery1 do
    begin
      Close;
      SQL.Clear;
      sql.Add('select A.*,B.* from BP_ZDY_Sub A ');
      Sql.Add('inner join KH_Zdy_Attachment B on A.HXATID=B.ATID and B.Type=''CPHX''');
      sql.Add(' where A.BPCode='''+trim(CDS_Sub.Fieldbyname('DLHXK').AsString)+'''');
      open;
    end;
    SCreateCDS20(ADOQuery1,Ord_HX);
    SInitCDSData20(ADOQuery1,Ord_HX);
  end;
end;

procedure TfrmMLMange_XH.Tv1DblClick(Sender: TObject);
begin
  TCK.Click;
end;

procedure TfrmMLMange_XH.TCKClick(Sender: TObject);
begin
  try
    frmMLManage_LRYH:=TfrmMLManage_LRYH.Create(Application);
    with frmMLManage_LRYH do
    begin
      FCYID:=Trim(Self.CDS_Main.fieldbyname('MLID').AsString);
      FGYName:='印花';
      formid:='1';
      //viewFlag:=True;
      TSave.Visible:=false;
      toolbutton1.Visible:=false;
      Button2.Visible:=false;
      if ShowModal=1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmMLManage_LRYH.Free;
  end;
end;

procedure TfrmMLMange_XH.ToolButton11Click(Sender: TObject);
begin
  try
    frmMLManage_LRYH:=TfrmMLManage_LRYH.Create(Application);
    with frmMLManage_LRYH do
    begin
      FCYID:='';
      FGYName:='印花';
      if ShowModal=1 then
      begin
        Self.InitGrid();
        CDS_Main.Locate('MLID',FCYID,[]);
      end;
    end;
  finally
    frmMLManage_LRYH.Free;
  end;
end;

procedure TfrmMLMange_XH.TPrintClick(Sender: TObject);
begin
  frmHXKTJ:=TfrmHXKTJ.create(self);
  with frmHXKTJ do
  begin
    TJHX.Text:=Trim(CDS_Main.fieldbyname('TJML').AsString);
    if ShowModal=1 then
    begin

    end;
    free;
  end;
end;

procedure TfrmMLMange_XH.FormCreate(Sender: TObject);
begin
  canshu1:=Trim(DParameters1);
end;

procedure TfrmMLMange_XH.N1Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  try
    frmMLManage_LRYH:=TfrmMLManage_LRYH.Create(Application);
    with frmMLManage_LRYH do
    begin
      FCYID:=Trim(Self.CDS_Main.fieldbyname('MLID').AsString);
      FGYName:='印花';
      Panel7.Visible:=false;
      Button2.Visible:=false;
      Button3.Visible:=false;
      Panel10.Visible:=false;
      TJGYName.Enabled:=false;
      TJGYName.Color:=clScrollBar;
      if ShowModal=1 then
      begin
        Self.InitGrid();
        CDS_Main.Locate('MLID',FCYID,[]);
      end;
    end;
  finally
    frmMLManage_LRYH.Free;
  end;
end;

procedure TfrmMLMange_XH.N2Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  with ADOQueryCmd do
  begin
    close;
    sql.Clear;
    SQL.Add('select * from BP_DY ');
    sql.Add('where MLID='''+trim(CDS_Main.fieldbyname('MLID').AsString)+'''');
    Open;
  end;
  if ADOQueryCmd.IsEmpty=false then
  begin
    if Application.MessageBox('数据已打印确定要删除吗?','提示',32+4)<>IDYES then Exit;
    //exit;
  end
  else
  begin
    if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  end;
  with ADOQueryCmd do
  begin
    Close;
    SQL.Clear;
    sql.Add('delete ML_Manage where MLID='''+Trim(CDS_Main.fieldbyname('MLID').AsString)+'''');
    sql.Add('delete ML_Manage_PB where MLID='''+Trim(CDS_Main.fieldbyname('MLID').AsString)+'''');
    sql.Add('delete ML_Manage_GX where MLID='''+Trim(CDS_Main.fieldbyname('MLID').AsString)+'''');
    //sql.Add('delete Image_Info where TJML='''+Trim(CDS_Main.fieldbyname('TJML').AsString)+'''');
    ExecSQL;
  end;
  CDS_Main.Delete;
end;

procedure TfrmMLMange_XH.N3Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  try
    frmMLManage_LRYH:=TfrmMLManage_LRYH.Create(Application);
    with frmMLManage_LRYH do
    begin
      FCYID:=Trim(Self.CDS_Main.fieldbyname('MLID').AsString);
      FGYName:='印花';
      FOrmid:='1';
      if ShowModal=1 then
      begin
        Self.InitGrid();
        CDS_Main.Locate('MLID',FCYID,[]);
      end;
    end;
  finally
    frmMLManage_LRYH.Free;
  end;
end;

procedure TfrmMLMange_XH.Button1Click(Sender: TObject);
begin
  frmSCPerson:=TfrmSCPerson.Create(Application);
  with frmSCPerson do
  begin
    FlagStr:='YHHXZDYType';
    if ShowModal=1 then
    begin
      HXType.Text:=Trim(FSDPerson);
    end;
    free;
  end;
end;

procedure TfrmMLMange_XH.HXTypeChange(Sender: TObject);
begin
  ToolButton2.Click;
end;

procedure TfrmMLMange_XH.N4Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  try
    frmMLManage_LRYH:=TfrmMLManage_LRYH.Create(Application);
    with frmMLManage_LRYH do
    begin
      FCYID:=Trim(Self.CDS_Main.fieldbyname('MLID').AsString);
      FGYName:='印花';
      FOrmid:='2';
      if ShowModal=1 then
      begin
        Self.InitGrid();
        CDS_Main.Locate('MLID',FCYID,[]);
      end;
    end;
  finally
    frmMLManage_LRYH.Free;
  end;
end;

procedure TfrmMLMange_XH.ToPrintClick(Sender: TObject);
begin
  Panel2.Visible:=true;
end;

procedure TfrmMLMange_XH.cxButton1Click(Sender: TObject);
var
   fPrintFile,Txt,fImagePath,maxno:string;
   i,j:Integer;
   Moudle: THandle;
   Makebar:TMakebar;
   Mixtext:TMixtext;
begin
  if CDS_Main.IsEmpty then Exit;
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\印花面料标签.rmf';
  if FileExists(fPrintFile)=False then
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\印花面料标签.rmf'),'提示',0);
    exit;
  end;
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    //First;
    //while Locate('SSel',True,[]) do
    begin
      try
        ADOQueryCmd.Connection.BeginTrans;
        if GetLSNo(ADOQueryCmd,maxno,'TGML','BP_DY',4,1,)=False then
        begin
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('取样品打印最大号失败!','提示',0);
          Exit;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          SQL.Add('select * from BP_DY where DYId='''+Trim(maxno)+'''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          Append;
          FieldByName('MLID').Value:=Trim(CDS_Main.fieldbyname('MLID').AsString);
          FieldByName('TFID').Value:=Trim(CDS_Main.fieldbyname('PTID').AsString);
          FieldByName('DYId').Value:=Trim(maxno);
          FieldByName('Filler').Value:=Trim(DName);
          FieldByName('FillerCode').Value:=Trim(DCode);
          FieldByName('Valid').Value:='Y';
          Post;
        end;
        ADOQueryCmd.Connection.CommitTrans;
      except
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('保存打印流水号异常！','提示',0);
        Exit;
      end;
      try
        Moudle:=LoadLibrary('MakeQRBarcode.dll');
        @Makebar:=GetProcAddress(Moudle,'Make');
        @Mixtext:=GetProcAddress(Moudle,'MixText');
        Txt:=Trim(maxno);
        fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp';
        if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
        if FileExists(fImagePath) then DeleteFile(fImagePath);
        Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
      except
        application.MessageBox('二维码生成失败！','提示信息',MB_ICONERROR);
        exit;
      end;
      RMVariables['QRBARCODE']:=fImagePath;
      RMVariables['DYID']:=maxno;
      RM1.LoadFromFile(fPrintFile);
      //RM1.ShowReport;
      RM1.PrintReport;
    end;
  end;
  CDS_Main.EnableControls;
  panel2.Visible:=false;
end;

procedure TfrmMLMange_XH.Image1Click(Sender: TObject);
begin
  panel2.Visible:=False;
end;

procedure TfrmMLMange_XH.cxButton2Click(Sender: TObject);
begin
  frmMLManage_LRYHDY:=TfrmMLManage_LRYHDY.Create(self);
  with frmMLManage_LRYHDY do
  begin
    FCYID:=Trim(Self.CDS_Main.fieldbyname('MLID').AsString);
    FGYName:='印花';
    formid:='1';
    if ShowModal=1 then
    begin

    end;
    free;
  end;
  panel2.Visible:=false;
end;

procedure TfrmMLMange_XH.cxButton3Click(Sender: TObject);
begin
  frmMLManage_LRYHDY:=TfrmMLManage_LRYHDY.Create(self);
  with frmMLManage_LRYHDY do
  begin
    formid:='2';
    FCYID:=Trim(Self.CDS_Main.fieldbyname('MLID').AsString);
    FGYName:='印花';
    if ShowModal=1 then
    begin

    end;
    free;
  end;
  panel2.Visible:=false;
end;

end.


